<template>
	<div class="stats">

		<div class="base_block p-3 mb-3">
			<form class="dash_ftr" @submit.prevent="getData()">

				<div class="d-flex align-items-center py-2 mr-4 position-relative">
					<label style="width: 140px;" class="col-form-label">{{$store.state.locale.beginDate}}:</label>
					<datepicker
							v-model="fromDate"
							:config="options">
					</datepicker>
				</div>

				<div class="d-flex align-items-center py-2 mr-4 position-relative">
					<label style="width: 180px;" class="col-form-label">{{$store.state.locale.endDate}}:</label>
					<datepicker
							v-model="toDate"
							:config="options">
					</datepicker>
				</div>


				<button type="submit" class="btn call_save_btn dash_ftr_btn">{{ $store.state.locale.filter }}
				</button>
			</form>
		</div>


		<div class="mb-5">
			<div class="row dn_table" v-for="statistic in statisticsList">
				<div class="col-2">
					<h3>
						<div style="background: #4DD24B;">
							{{statistic.totalCalls}}
						</div>
						<span style="color: #4DD24B;">{{$store.state.locale.totalCalls}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #2ABAEE;">
							{{statistic.openedCards}}
						</div>
						<span style="color: #2ABAEE;">{{$store.state.locale.openedCards}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #2ABAEE;">
							{{statistic.closedCards}}
						</div>
						<span  style="color: #2ABAEE;">{{$store.state.locale.closedCards}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #2ABAEE;">
							{{statistic.differenceOfCards}}
						</div>
						<span  style="color: #2ABAEE;">{{$store.state.locale.differenceOfCards}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #FF8D8D;">
							{{statistic.openedCrashNews}}
						</div>
						<span style="color: #FF8D8D;">{{$store.state.locale.openedCrashNews}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #FF8D8D;">
							{{statistic.closedCrashNews}}
						</div>
						<span style="color: #FF8D8D;">{{$store.state.locale.closedCrashNews}}</span>
					</h3>
				</div>
			</div>
		</div>

		<div>
			<h3 class="mb-2">
				Статистика за текущий месяц
			</h3>
			<div class="row dn_table" v-for="statistic in statisticsListMonth">
				<div class="col-2">
					<h3>
						<div style="background: #4DD24B;">
							{{statistic.totalCalls}}
						</div>
						<span style="color: #4DD24B;">{{$store.state.locale.totalCalls}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #2ABAEE;">
							{{statistic.openedCards}}
						</div>
						<span style="color: #2ABAEE;">{{$store.state.locale.openedCards}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #2ABAEE;">
							{{statistic.closedCards}}
						</div>
						<span  style="color: #2ABAEE;">{{$store.state.locale.closedCards}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #2ABAEE;">
							{{statistic.differenceOfCards}}
						</div>
						<span  style="color: #2ABAEE;">{{$store.state.locale.differenceOfCards}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #FF8D8D;">
							{{statistic.openedCrashNews}}
						</div>
						<span style="color: #FF8D8D;">{{$store.state.locale.openedCrashNews}}</span>
					</h3>
				</div>
				<div class="col-2">
					<h3>
						<div style="background: #FF8D8D;">
							{{statistic.closedCrashNews}}
						</div>
						<span style="color: #FF8D8D;">{{$store.state.locale.closedCrashNews}}</span>
					</h3>
				</div>
			</div>
		</div>

	</div>

</template>

<script>
	import Datepicker from "vue-bootstrap-datetimepicker";
	import 'pc-bootstrap4-datetimepicker/build/css/bootstrap-datetimepicker.css';

	export default {
		name: "index",
		components: {Datepicker},
		data() {
			return {
				statisticsListMonth: [],
				intervalMonth: 0,
				interval: 0,
				statisticsList: [],
				fromDate: '',
				toDate: '',
				options: {
					format: 'YYYY-MM-DD',
					useCurrent: false,
					showClear: true,
					showClose: true,
					locale: 'ru',
					icons: {
						time: 'mdi mdi-clock-outline',
						date: 'mdi mdi-calendar',
						up: 'mdi mdi-arrow-up',
						down: 'mdi mdi-arrow-down',
						previous: 'mdi mdi-arrow-left',
						next: 'mdi mdi-arrow-right',
						today: 'mdi mdi-calendar-today',
						clear: 'mdi mdi-delete-outline',
						close: 'mdi mdi-alpha-x-circle-outline'
					}
				}
			}
		},
		created() {
			this.getDataForMonth();
			this.intervalMonth = setInterval(
				this.getDataForMonth, 5000
			)
			this.getData();
			this.interval = setInterval(
				this.getData, 5000
			)
		},
		beforeDestroy(){
			clearInterval(this.interval);
			clearInterval(this.intervalMonth);
		},
		methods: {
			getDataForMonth() {
				let from, to;
				to = moment(new Date()).format('YYYY-MM-DD');
				from = to.split('-');
				from[2] = '01';
				from = from.join('-');
				axios.post('HokimiyatNews/statisticsReport', {
					from,
					to
				})
					.then(response => {
						let newArr = []
						newArr.push(response.data)
						this.statisticsListMonth = newArr
					})
					.catch(error => {
						console.log(error.message)
					});
			},
			getData() {
				let from, to;
				if (this.fromDate || this.toDate) {
					from = this.fromDate;
					to = this.toDate;
				} else {
					let newDate = moment(new Date()).format('YYYY-MM-DD')
					from = newDate;
					this.fromDate = newDate;
					to = newDate;
					this.toDate = newDate;
				}

				// let from = moment(newDate).subtract(7,'d').format('YYYY-MM-DD')
				// let to = moment(newDate).format('YYYY-MM-DD')
				axios.post('HokimiyatNews/statisticsReport', {
						from,
						to
					})
					.then(response => {
						let newArr = []
						newArr.push(response.data)
						this.statisticsList = newArr
					})
					.catch(error => {
						console.log(error.message)
					});
			}
		}
	}
</script>

<style scoped>
	.dn_table h3{
		overflow: hidden;
		text-align: center;
		border-radius: 4px;
		box-shadow: 2px 2px 2px #cccccc;;
	}
	.dn_table h3>div{
		font-family: Roboto;
		font-size: 46px;
		color: #fff;
		font-weight: bold;
		margin: 0;
		padding: 24px 0;
		border-bottom: 1px solid #E2E5EB;
	}
	.dn_table h3>span{
		font-family: Roboto;
		display: block;
		font-size: 16px;
		font-weight: medium;
		margin: 0;
		background: #fff;
		padding: 22px 0;
	}

</style>